#include "mamin_program_main.h"


LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
/* Make the class name into a global variable */

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    InitSvega();
    HWND hwnd;
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon(hThisInstance, "ikonica");
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           szAppName,         /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           iAppWidth,                 /* The programs width */
           iAppHeight,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
    /* Make the window visible on the screen */
    ShowWindow(hwnd, SW_MAXIMIZE );
    /* Run the message loop. It will run until GetMessage( ) returns 0 */

    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Translate virtual-key messages into character messages */
           TranslateMessage(&messages);
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}

/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int temp, temp1, x = iPoljeStartX, y = iPoljeStartY;
    static HWND PoljeText[N_STAVKI*31];
    static HWND SledeciMesecDugme, PrethodniMesecDugme, SledecaGodinaDugme,
                PrethodnaGodinaDugme, IzracunajUkupnoDugme,
                IzracunajKozmetikuDugme, IsprintajDugme;
    static HWND DatumiText[31];
    int cyChar, cxChar;
    long rezultat;
    char bufer[50];

    HDC hdc;
    PAINTSTRUCT ps;



    switch (message)                  /* handle the messages */
    {
         case WM_CREATE:
           /* -------- Iscrtaj polja ---------*/
           for ( temp = 0; temp < N_STAVKI*31; temp++ ){
             if( (temp) % N_STAVKI == 0 && temp>0 ){
               x = iPoljeStartX;
               y += iPoljeHeight + iPoljeDy;
             }
             idPolje[temp] =   temp;
             PoljeText[temp] = CreateWindow(  "edit",
                                              NULL,
                                              WS_CHILD | WS_VISIBLE | WS_BORDER | ES_NUMBER,
                                              x , y ,
                                              iPoljeWidth, iPoljeHeight,
                                              hwnd,
                                              (HMENU) idPolje[temp],
                                              ((LPCREATESTRUCT) lParam) -> hInstance,
                                              NULL );
             // promeni proceduru:
             StaraProceduraTexta = (WNDPROC) SetWindowLong( PoljeText[temp],
                                                            GWL_WNDPROC,
                                                            (LONG)NovaProceduraTexta );
             x += iPoljeWidth + iPoljeDx;
           }
           /*PromeniMesecPolja( TrenutanMesec.Mesec , PoljeText );
             Ovo neka uradi posle datuma...
           */
           SetFocus ( PoljeText[0] );
           TrenutnaPozicija = 0;
           /* ---- Uradi dugmice : ------------*/
           cxChar = LOWORD (GetDialogBaseUnits ()) ;
           cyChar = HIWORD (GetDialogBaseUnits ()) ;

           SledeciMesecDugme = CreateWindow( "button",
                                             szSledeciMesecDugme,
                                             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                             iSledeciMesecDugmeX,
                                             iSledeciMesecDugmeY,
                                             (strlen( szSledeciMesecDugme)+3) * cxChar,
                                             cyChar+6,
                                             hwnd,
                                             (HMENU) idSledeciMesecDugme,
                                             ((LPCREATESTRUCT) lParam)->hInstance,
                                             NULL);  
           PrethodniMesecDugme = CreateWindow( "button",
                                             szPrethodniMesecDugme,
                                             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                             iPrethodniMesecDugmeX,
                                             iPrethodniMesecDugmeY,
                                             (strlen( szPrethodniMesecDugme )+3) * cxChar,
                                             cyChar+6,
                                             hwnd,
                                             (HMENU) idPrethodniMesecDugme,
                                             ((LPCREATESTRUCT) lParam)->hInstance,
                                             NULL);
           SledecaGodinaDugme = CreateWindow( "button",
                                             szSledecaGodinaDugme,
                                             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                             iSledecaGodinaDugmeX,
                                             iSledecaGodinaDugmeY,
                                             (strlen( szSledecaGodinaDugme )+3) * cxChar,
                                             cyChar+6,
                                             hwnd,
                                             (HMENU) idSledecaGodinaDugme,
                                             ((LPCREATESTRUCT) lParam)->hInstance,
                                             NULL);
           PrethodnaGodinaDugme = CreateWindow( "button",
                                             szPrethodnaGodinaDugme,
                                             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                             iPrethodnaGodinaDugmeX,
                                             iPrethodnaGodinaDugmeY,
                                             (strlen( szPrethodnaGodinaDugme )+3) * cxChar,
                                             cyChar+6,
                                             hwnd,
                                             (HMENU) idPrethodnaGodinaDugme,
                                             ((LPCREATESTRUCT) lParam)->hInstance,
                                             NULL);
           if( TrenutanDatum.Godina == NAJMANJA_GODINA ){
             EnableWindow( PrethodnaGodinaDugme, 0 );
           }
           /* ----------- Iscrtaj datume pored lise --------*/
           x = iStartDatumiTextX;
           y = iStartDatumiTextY;
           for( temp = 0; temp < 31; temp ++ ){
             idDatumiText[temp] = idPrethodnaGodinaDugme +1 + temp;
             DatumiText[temp] = CreateWindow(  "edit",
                                               NULL,
                                               WS_CHILD | WS_VISIBLE | WS_DISABLED	,
                                               x , y ,
                                               cxChar*10, iDatumiTextHeight,
                                               hwnd,
                                               (HMENU) idDatumiText[temp],
                                               ((LPCREATESTRUCT) lParam) -> hInstance,
                                               NULL );
             y += iDatumiTextDy + iDatumiTextHeight;

           }
           /*------------ Iscrtaj dugmice za izracunavanje --------*/
           IzracunajUkupnoDugme = CreateWindow( "button",
                                                szIzracunajUkupnoDugme,
                                                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                                iIzracunajUkupnoDugmeX,
                                                iIzracunajUkupnoDugmeY,
                                                (strlen( szIzracunajUkupnoDugme )+3) * cxChar,
                                                cyChar+6,
                                                hwnd,
                                                (HMENU) idIzracunajUkupnoDugme,
                                                ((LPCREATESTRUCT) lParam)->hInstance,
                                                NULL);
           IzracunajKozmetikuDugme = CreateWindow( "button",
                                                   szIzracunajKozmetikuDugme,
                                                   WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                                   iIzracunajKozmetikuDugmeX,
                                                   iIzracunajKozmetikuDugmeY,
                                                   (strlen( szIzracunajKozmetikuDugme )+3) * cxChar,
                                                   cyChar+6,
                                                   hwnd,
                                                   (HMENU) idIzracunajKozmetikuDugme,
                                                   ((LPCREATESTRUCT) lParam)->hInstance,
                                                   NULL);
           IsprintajDugme = CreateWindow( "button",
                                          szIsprintajDugme,
                                          WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                          iIsprintajDugmeX,
                                          iIsprintajDugmeY,
                                          (strlen( szIsprintajDugme )+3) * cxChar,
                                          cyChar+6,
                                          hwnd,
                                          (HMENU) idIsprintajDugme,
                                          ((LPCREATESTRUCT) lParam)->hInstance,
                                          NULL);
           PromeniMesecPolja( TrenutanMesec.Mesec , PoljeText, DatumiText );

           return 0;
         case WM_PAINT:
           /*A sada, ISCRTAJ NASLOVE -------------*/
           hdc = BeginPaint( hwnd, &ps );

           x = iPoljeStartX;
           y = 2;
           for( int temp = 0; temp < N_STAVKI; temp++ ){
             TextOut( hdc, x, y, Ime[temp], strlen(Ime[temp]) );
             x += iPoljeWidth + iPoljeDx;
           };

           EndPaint( hwnd, &ps );
           return 0;
         case WM_COMMAND:
           switch( LOWORD(wParam) ){
              case idSledeciMesecDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                TrenutanDatum.Mesec++;
                if( TrenutanDatum.Mesec > 12 ){
                  TrenutanDatum.Mesec = 1;
                  TrenutanDatum.Godina ++;
                  UcitajGodinu( TrenutnaGodina, TrenutanDatum.Godina );
                }
                PromeniMesecPolja( TrenutanDatum.Mesec, PoljeText, DatumiText );
                EnableWindow( PrethodniMesecDugme, 1);
                break;
              case idPrethodniMesecDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                TrenutanDatum.Mesec--;
                if( TrenutanDatum.Mesec < 2 && TrenutanDatum.Godina == NAJMANJA_GODINA){
                  PromeniMesecPolja( TrenutanDatum.Mesec, PoljeText, DatumiText );
                  EnableWindow( PrethodniMesecDugme, 0 );
                  break;
                }
                if( TrenutanDatum.Mesec < 1 ){
                  TrenutanDatum. Mesec = 12;
                  TrenutanDatum. Godina --;
                  UcitajGodinu( TrenutnaGodina, TrenutanDatum.Godina );
                }
                PromeniMesecPolja( TrenutanDatum.Mesec, PoljeText, DatumiText );
                break;
              case idSledecaGodinaDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                TrenutanDatum.Godina++;
                UcitajGodinu( TrenutnaGodina, TrenutanDatum.Godina );
                PromeniMesecPolja( TrenutanDatum.Mesec, PoljeText, DatumiText );
                EnableWindow( PrethodnaGodinaDugme, 1 );
                break;
              case idPrethodnaGodinaDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                TrenutanDatum.Godina --;
                if( TrenutanDatum.Godina -1 < NAJMANJA_GODINA ){
                  EnableWindow( PrethodnaGodinaDugme, 0 );
                }
                UcitajGodinu( TrenutnaGodina, TrenutanDatum.Godina );
                PromeniMesecPolja( TrenutanDatum.Mesec, PoljeText, DatumiText );
                break;
              case idIzracunajUkupnoDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                rezultat = IzracunajUkupno( TrenutnaGodina );
                wsprintf(bufer, "Sve ukupno  je %d euroa.", rezultat);
                MessageBox( hwnd, bufer, "Rezultat:", 0 );
                break;
              case idIzracunajKozmetikuDugme:
                UpdateGodinu( TrenutnaGodina, PoljeText );
                SnimiGodinu( TrenutnaGodina );
                rezultat = IzracunajKozmetiku( TrenutnaGodina );
                wsprintf(bufer, "Sva kozmetika je %d euroa.", rezultat);
                MessageBox( hwnd, bufer, "Rezultat:", 0 );
                break;
              case idIsprintajDugme:

                break;
           }
           return 0;
         case WM_DESTROY:
           UpdateGodinu( TrenutnaGodina, PoljeText );
           SnimiGodinu( TrenutnaGodina );
           PostQuitMessage(0);        /* send a WM_QUIT to the message queue */
           break;
           default:                   /* for messages that we don't deal with */
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}



/* ------------------------------------ Moje Funkcije: ---------------*/
void InitSvega(){
  SYSTEMTIME *lpSystemTime;
  GetSystemTime( lpSystemTime );


  UcitajGodinu( TrenutnaGodina, 2002 );
  TrenutanDatum.Dan = lpSystemTime -> wDay;
  TrenutanDatum.Mesec = lpSystemTime -> wMonth;
  TrenutanDatum.Godina = lpSystemTime -> wYear;
  TrenutanMesec.Napuni( TrenutanDatum.Mesec, TrenutnaGodina );


  /* Ubaci naslove*/
  strcpy( Ime[0], "Nada" );
  strcpy( Ime[1], "Sneza" );
  strcpy( Ime[2], "Svetlana" );
  strcpy( Ime[3], "Kreme" );
  strcpy( Ime[4], "Beljenje" );
  strcpy( Ime[5], "Ostalo" );
}

FajlTip :: FajlTip() {
  for ( int temp = 0; temp < 366; temp ++ ){
    for ( int temp1 = 0; temp1 < N_STAVKI; temp1++ ){
      Vrednost[temp1][temp] = 0;
    }
  }
  return;
}

void FajlTip :: Izmeni( DatumTip Datum, int ime, unsigned short vrednost ){
  unsigned short Dan = GetDan( Datum );
  Dan --;
  Vrednost [ime][Dan] = vrednost;
  return;
}

unsigned short FajlTip :: GetVrednost( DatumTip Datum, int ime ){
  return Vrednost[ ime ][ GetDan(Datum)-1 ];
}

DatumTip FillDatum( unsigned short Dan, unsigned short Mesec, unsigned short Godina ){
  DatumTip Rezult;
  Rezult.Dan = Dan;
  Rezult.Mesec = Mesec;
  Rezult.Godina = Godina;
};

int DatumJeOk( DatumTip Datum ){
  unsigned short BrojDanaUMesecu[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  if( Datum.Godina % 4 == 0 ){
    BrojDanaUMesecu[1] = 29;
  }
  if( Datum.Godina < NAJMANJA_GODINA || Datum.Dan > BrojDanaUMesecu[Datum.Mesec-1]
      || Datum.Mesec < 0 || Datum.Mesec > 12){
    return 0;
  }
  return 1;
}


DatumTip GetDatum( unsigned short Dan, unsigned short Godina ){
  unsigned short BrojDanaUMesecu[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  DatumTip Rezultat = {0, 0, 0};
  short temp = -1;
  short BrojProslihDana = Dan;
  Rezultat.Godina = Godina;

  if( Godina % 4 == 0 ){
    BrojDanaUMesecu[1] = 29;
  }
  if( (Dan > 365 && BrojDanaUMesecu[1] == 28) || (Dan > 366 && BrojDanaUMesecu[1] == 29) ){
    Rezultat.Dan = 0;
    Rezultat.Mesec = 0;
    Rezultat.Godina = 0;
    return Rezultat;
  }

  for( temp = 0; temp < 13; temp++ ){
    if( BrojProslihDana - BrojDanaUMesecu[temp] < 1 ) break;
    BrojProslihDana -= BrojDanaUMesecu[temp];
  }
  Rezultat.Mesec = temp +1;
  Rezultat.Dan = BrojProslihDana;
  return Rezultat;
}

unsigned short GetDan( DatumTip Datum ){
  unsigned short BrojDanaUMesecu[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  unsigned short temp;
  unsigned short Dan = 0;

  if( Datum.Godina % 4 == 0 ){
    BrojDanaUMesecu[1] = 29;
  }
  if( !DatumJeOk( Datum ) ){
      return 0;
  }

  for( temp = 0; temp < Datum.Mesec-1; temp++ ){
    Dan += BrojDanaUMesecu[temp];
  }
  Dan += Datum.Dan;
  return Dan;
}

unsigned short BrojDanaUMesecu( unsigned short Mesec, unsigned short Godina ){

    unsigned short BrojDanaUMesecu1[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    if( Godina % 4 == 0 ){
      BrojDanaUMesecu1[1] = 29;
    }
    return BrojDanaUMesecu1[Mesec -1];
}

void UcitajGodinu( FajlTip& TrenutnaGodina, unsigned short Godina ){
  FILE *fajl;
  char bufer[50];
  wsprintf( bufer, "%d.dat", Godina );
  if( !(fajl = fopen( bufer, "r" )) ){
    // Fajl ne postoji, napravi novi prazan:
    FajlTip TempFajl;
    TempFajl.Godina = Godina;
    fajl = fopen( bufer, "w" );
    fwrite( &TempFajl, sizeof( TempFajl ), 1, fajl );
    fclose ( fajl );
    TrenutnaGodina = TempFajl;
    return;
  } else {
    fread( &TrenutnaGodina, sizeof( TrenutnaGodina ), 1, fajl );
    fclose (fajl);
  }
}

void SnimiGodinu( FajlTip& TrenutnaGodina ){
  FILE *fajl;
   char bufer[50];

   wsprintf( bufer, "%d.dat", TrenutnaGodina.Godina );
   fajl = fopen( bufer, "w" );
   fwrite( &TrenutnaGodina, sizeof( TrenutnaGodina ), 1, fajl );
   fclose ( fajl );
}

void UpdateGodinu( FajlTip& TrenutnaGodina, HWND* PoljeText ){
   int br = 0,temp = 0, temp1 = 0;
   DatumTip dStart = FillDatum( 1, TrenutanMesec.Mesec, TrenutanMesec.Godina );
   DatumTip dKraj = FillDatum( BrojDanaUMesecu(TrenutanMesec.Mesec, TrenutanMesec.Godina), TrenutanMesec.Mesec, TrenutanMesec.Godina );
   int Start = GetDan( dStart )-1;
   int Kraj = GetDan( dKraj )-1;
   for( temp = Start; temp < Kraj+1; temp++){
     for( temp1 = 0; temp1<N_STAVKI; temp1++ ){
       TrenutnaGodina.Vrednost[temp1][temp] = atoi( UzmiText(PoljeText[br]) );
       br++;
     }
   }
   return;
}

long IzracunajUkupno( FajlTip& TrenutnaGodina ){
  long Rezultat = 0;
  int temp, temp1;
  for( temp = 0; temp < 366; temp++ ){
    for( temp1 = 0; temp1 < N_STAVKI; temp1++){
      Rezultat += TrenutnaGodina.Vrednost[temp1][temp];
    }
  }
  return Rezultat;
}

long IzracunajKozmetiku( FajlTip& TrenutnaGodina ){
  long Rezultat  = 0;
  int temp, temp1;
  for( temp = 0; temp < 366; temp++ ){
    for( temp1 = 3; temp1 < 5; temp1++){
      Rezultat += TrenutnaGodina.Vrednost[temp1][temp];
    }
  }
  return Rezultat;
}

void MesecTip :: Napuni( unsigned short MesecIn, FajlTip& TrenutnaGodina ){
  Godina = TrenutnaGodina.Godina;
  Mesec = MesecIn;

  DatumTip DatumPocetak = {1, Mesec, Godina};
  DatumTip DatumKraj = { BrojDanaUMesecu( Mesec, Godina ), Mesec, Godina };

  int Pocetak = GetDan( DatumPocetak ) -1;
  int Kraj = GetDan( DatumKraj ) -1;
  BrojRekorada =  BrojDanaUMesecu( Mesec, Godina ) -1;

  for( int temp = Pocetak; temp < Kraj +1; temp++ ){
    for( int temp1 = 0; temp1 < N_STAVKI; temp1++ ){
      Vrednost[ temp1 ][ temp - Pocetak ] = TrenutnaGodina.Vrednost[temp1][temp] ;
    }
  }
  return;
}

void PromeniText( HWND textbox, char* text ){
  SendMessage( textbox, WM_SETTEXT, 0, (LPARAM)text );
  return;
}

char* UzmiText( HWND textbox ){
  char* Rezultat = new char[100];
  GetWindowText( textbox, Rezultat, 100 );
  return Rezultat;
};

int UzmiBroj( HWND textbox ){
  char* bufer;
  bufer = UzmiText( textbox );
  return atoi( bufer );
}

void PromeniMesecPolja( unsigned short Mesec, HWND* PoljeText, HWND* DatumiText ){
  int temp, temp1;
  char bufer[50];
  int DanTemp = 0;

  TrenutanMesec.Napuni( Mesec, TrenutnaGodina );
  for( temp = 0; temp < N_STAVKI * BrojDanaUMesecu( TrenutanMesec.Mesec, TrenutanMesec.Godina ); temp++){
    wsprintf( bufer, "%d", TrenutanMesec.Vrednost[temp%N_STAVKI][temp/N_STAVKI] );
    PromeniText( (HWND)(PoljeText[temp]), bufer);
  }
  for( temp = 0; temp < BrojDanaUMesecu ( TrenutanMesec.Mesec, TrenutanMesec.Godina ); temp++ ){
    DanTemp ++;
    if( DanTemp < 10 ){
      wsprintf( bufer, "0%d.%d.%d.", DanTemp, TrenutanMesec.Mesec, TrenutanMesec.Godina );
    } else {
      wsprintf( bufer, "%d.%d.%d.", DanTemp, TrenutanMesec.Mesec, TrenutanMesec.Godina );
    }
    PromeniText( (HWND)(DatumiText[temp] ), bufer);
  }

  // ovo nazalost mora da bude ovako bez veze :(
  for( temp = 0; temp < N_STAVKI * 31; temp++) ShowWindow( PoljeText[temp],SW_SHOW);
  for( temp = 0; temp < 31; temp++) ShowWindow( DatumiText[temp], SW_SHOW );
  for( temp = N_STAVKI * BrojDanaUMesecu( TrenutanMesec.Mesec, TrenutanMesec.Godina );
       temp < N_STAVKI * 31; temp++ ){
    ShowWindow( PoljeText[temp], SW_HIDE );
  }
  for ( temp = BrojDanaUMesecu( TrenutanMesec.Mesec, TrenutanMesec.Godina );
        temp < 31; temp++ ){
     ShowWindow( DatumiText[temp], SW_HIDE );
  }
  return;
}

void test( int i , char* naslov){
  char bufer[50];
  wsprintf( bufer, "%d", i );
  MessageBox (NULL, naslov , bufer, 0);
  return;
}



/*----------------- WINDOWSove nadogradjene funkcije: -------------*/
LRESULT CALLBACK NovaProceduraTexta(HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam){
  switch( Msg ){
    case WM_SETFOCUS:
      TrenutnaPozicija = GetDlgCtrlID( hwnd );
    case WM_KEYDOWN:
      switch( wParam ){
         case VK_DOWN:
           TrenutnaPozicija += N_STAVKI;
            if( TrenutnaPozicija > (TrenutanMesec.BrojRekorada+1) * N_STAVKI-1 ){
              TrenutnaPozicija -= N_STAVKI;
            }
            SetFocus( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ) );
            SendMessage( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ), EM_SETSEL, 0, 100) ;
            break;
         case VK_UP:
            TrenutnaPozicija -= N_STAVKI;
            if( TrenutnaPozicija < 0 ){
              TrenutnaPozicija += N_STAVKI;
            }
            SetFocus( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ) );
            SendMessage( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ), EM_SETSEL, 0, 100) ;
            break;
         case VK_LEFT:
            TrenutnaPozicija -=1;
            if( TrenutnaPozicija < 0 ) TrenutnaPozicija = 0;
            SetFocus( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ) );
            SendMessage( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ), EM_SETSEL, 0, 100) ;
            break;
         case VK_RIGHT:
            TrenutnaPozicija +=1;
            if( TrenutnaPozicija > (TrenutanMesec.BrojRekorada+1)*N_STAVKI-1 ) TrenutnaPozicija -= 1;
            SetFocus( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ) );
            SendMessage( GetDlgItem( GetParent(hwnd), idPolje[TrenutnaPozicija] ), EM_SETSEL, 0, 100) ;
            break;
      }
    break;
  }
  return CallWindowProc(StaraProceduraTexta, hwnd, Msg, wParam, lParam);
};

HDC GetDCPrintera(){
  DWORD dwPotrebnoBajtova, dwDobijenoBajtova;
  HDC hdcPrintera;
  PRINTER_INFO_5 * pInfo5;

  // Pozovi da vidis koliko je bajtova potrebno:
  EnumPrinters( PRINTER_ENUM_DEFAULT, NULL, 5, NULL,
                0, &dwPotrebnoBajtova, &dwDobijenoBajtova);
  // Rezervisi memoriju:
  pInfo5 = (PRINTER_INFO_5*) malloc( dwPotrebnoBajtova );
  EnumPrinters( PRINTER_ENUM_DEFAULT, NULL, 5, (PBYTE) pInfo5,
                dwPotrebnoBajtova, &dwPotrebnoBajtova, &dwDobijenoBajtova);
  hdcPrintera = CreateDC( NULL, pInfo5 -> pPrinterName, NULL, NULL );

  free ( pInfo5 );
  return hdcPrintera;
};

int IsprintajSve( HWND hwnd ){
  int Rezultat = 1;
  HDC hdcPrintera = GetDCPrintera ();
  static DOCINFO DocI = { sizeof(DOCINFO), "Lista" };

  hdcPrintera = GetDCPrintera();
    if( StartDoc( hdcPrintera, &DocI ) > 0 ){
      if( StartPage( hdcPrintera ) > 0
          && EndPage( hdcPrintera ) > 0 ){


        EndDoc( hdcPrintera );
      } else {
        Rezultat = 0;
      }
    } else {
      Rezultat = 0;
    };
  DeleteDC( hdcPrintera );

  return Rezultat;
};
